package Species.Translator;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    private static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "Species.Translator", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "Species.Translator", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
		processBA.raiseEvent(_activity, "activity_pause", activityBA.activity.isFinishing());
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
	
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL _st = null;
public static anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor = null;
public static String _talen = "";
public static anywheresoftware.b4a.sql.SQL.CursorWrapper _crabc = null;
public anywheresoftware.b4a.objects.EditTextWrapper _enaam = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlv = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lvnames = null;
public anywheresoftware.b4a.objects.collections.List[] _lnames = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblen = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblde = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblfr = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbles = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblit = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblpt = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblnl = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbldk = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblsc = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnabc = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lvabc = null;
public static String[] _letter = null;
public static String _vnaam = "";
public taal _taal = null;
public about _about = null;
public help _help = null;
public static String  _about_click() throws Exception{
 BA.debugLineNum = 78;BA.debugLine="StartActivity(About)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._about.getObject()));
 BA.debugLineNum = 79;BA.debugLine="End Sub";
return "";
}
public static String  _activity_create(boolean _firsttime) throws Exception{
 BA.debugLineNum = 43;BA.debugLine="If FirstTime = True Then";
if (_firsttime==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 44;BA.debugLine="talen = \"EN\"";
_talen = "EN";
 BA.debugLineNum = 45;BA.debugLine="End If";
};
 BA.debugLineNum = 47;BA.debugLine="ToastMessageShow(\"The search language is set to \" & talen & \". To change the language press the MENU-button\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("The search language is set to "+_talen+". To change the language press the MENU-button",anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 49;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 BA.debugLineNum = 50;BA.debugLine="File.Copy(File.DirAssets,\"species_translations.sql\",File.DirDefaultExternal,\"species_translations.sql\")";
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"species_translations.sql",anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"species_translations.sql");
 BA.debugLineNum = 51;BA.debugLine="End If";
};
 BA.debugLineNum = 53;BA.debugLine="If ST.IsInitialized = False Then";
if (_st.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 54;BA.debugLine="ST.Initialize(File.DirDefaultExternal, \"species_translations.sql\", False)";
_st.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"species_translations.sql",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 55;BA.debugLine="End If";
};
 BA.debugLineNum = 57;BA.debugLine="pnLV.Initialize(0)";
mostCurrent._pnlv.Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 BA.debugLineNum = 58;BA.debugLine="lvNames.Initialize(0)";
mostCurrent._lvnames.Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 BA.debugLineNum = 59;BA.debugLine="pnABC.Initialize(0)";
mostCurrent._pnabc.Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 BA.debugLineNum = 60;BA.debugLine="lvABC.Initialize(0)";
mostCurrent._lvabc.Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 BA.debugLineNum = 62;BA.debugLine="Activity.LoadLayout(\"LO_Translation\")";
mostCurrent._activity.LoadLayout("LO_Translation",mostCurrent.activityBA);
 BA.debugLineNum = 63;BA.debugLine="Activity.AddView(pnLV,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlv.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 64;BA.debugLine="Activity.AddView(pnABC,0%x,0%y,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnabc.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(0),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 65;BA.debugLine="pnLV.LoadLayout(\"LOListView\")";
mostCurrent._pnlv.LoadLayout("LOListView",mostCurrent.activityBA);
 BA.debugLineNum = 67;BA.debugLine="Activity.AddMenuItem(\"Select search language\", \"Taal\")";
mostCurrent._activity.AddMenuItem("Select search language","Taal");
 BA.debugLineNum = 68;BA.debugLine="activity.AddMenuItem(\"About\", \"About\")";
mostCurrent._activity.AddMenuItem("About","About");
 BA.debugLineNum = 69;BA.debugLine="activity.AddMenuItem(\"Help\", \"Help\")";
mostCurrent._activity.AddMenuItem("Help","Help");
 BA.debugLineNum = 70;BA.debugLine="LoadListView";
_loadlistview();
 BA.debugLineNum = 71;BA.debugLine="LoadABC";
_loadabc();
 BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 BA.debugLineNum = 236;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 BA.debugLineNum = 207;BA.debugLine="If Taal.talen = \"English\" Then";
if ((mostCurrent._taal._talen).equals("English")) { 
 BA.debugLineNum = 208;BA.debugLine="talen = \"EN\"";
_talen = "EN";
 BA.debugLineNum = 209;BA.debugLine="Else If Taal.talen = \"Deutsch\" Then";
}else if((mostCurrent._taal._talen).equals("Deutsch")) { 
 BA.debugLineNum = 210;BA.debugLine="talen = \"DE\"";
_talen = "DE";
 BA.debugLineNum = 211;BA.debugLine="Else If Taal.talen = \"Français\" Then";
}else if((mostCurrent._taal._talen).equals("Français")) { 
 BA.debugLineNum = 212;BA.debugLine="talen = \"FR\"";
_talen = "FR";
 BA.debugLineNum = 213;BA.debugLine="Else If Taal.talen = \"Italiano\" Then";
}else if((mostCurrent._taal._talen).equals("Italiano")) { 
 BA.debugLineNum = 214;BA.debugLine="talen = \"IT\"";
_talen = "IT";
 BA.debugLineNum = 215;BA.debugLine="Else If Taal.talen = \"Español\" Then";
}else if((mostCurrent._taal._talen).equals("Español")) { 
 BA.debugLineNum = 216;BA.debugLine="talen = \"ES\"";
_talen = "ES";
 BA.debugLineNum = 217;BA.debugLine="Else If Taal.talen = \"Português\" Then";
}else if((mostCurrent._taal._talen).equals("Português")) { 
 BA.debugLineNum = 218;BA.debugLine="talen = \"PT\"";
_talen = "PT";
 BA.debugLineNum = 219;BA.debugLine="Else If Taal.talen = \"Nederlands\" Then";
}else if((mostCurrent._taal._talen).equals("Nederlands")) { 
 BA.debugLineNum = 220;BA.debugLine="talen = \"NL\"";
_talen = "NL";
 BA.debugLineNum = 221;BA.debugLine="Else If Taal.talen = \"Dansk\" Then";
}else if((mostCurrent._taal._talen).equals("Dansk")) { 
 BA.debugLineNum = 222;BA.debugLine="talen = \"DK\"";
_talen = "DK";
 BA.debugLineNum = 223;BA.debugLine="Else If Taal.talen = \"Scientific\" Then";
}else if((mostCurrent._taal._talen).equals("Scientific")) { 
 BA.debugLineNum = 224;BA.debugLine="talen = \"ScientificName\"";
_talen = "ScientificName";
 BA.debugLineNum = 225;BA.debugLine="End If";
};
 BA.debugLineNum = 227;BA.debugLine="LoadListView		'' To load names in case the search language has been changed";
_loadlistview();
 BA.debugLineNum = 228;BA.debugLine="lvNames.Visible = True";
mostCurrent._lvnames.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 229;BA.debugLine="pnABC.Visible = True";
mostCurrent._pnabc.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 230;BA.debugLine="lvABC.Visible = True";
mostCurrent._lvabc.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 232;BA.debugLine="End Sub";
return "";
}
public static String  _bnext_click() throws Exception{
 BA.debugLineNum = 240;BA.debugLine="pnLV.Initialize(0)";
mostCurrent._pnlv.Initialize(mostCurrent.activityBA,BA.NumberToString(0));
 BA.debugLineNum = 241;BA.debugLine="Activity.LoadLayout(\"LO_Translation\")";
mostCurrent._activity.LoadLayout("LO_Translation",mostCurrent.activityBA);
 BA.debugLineNum = 242;BA.debugLine="Activity.AddView(pnLV,0%x,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlv.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(0),mostCurrent.activityBA),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 243;BA.debugLine="pnLV.LoadLayout(\"LOListView\")";
mostCurrent._pnlv.LoadLayout("LOListView",mostCurrent.activityBA);
 BA.debugLineNum = 244;BA.debugLine="LoadListView";
_loadlistview();
 BA.debugLineNum = 245;BA.debugLine="LoadABC";
_loadabc();
 BA.debugLineNum = 247;BA.debugLine="End Sub";
return "";
}
public static String  _bsearch_click() throws Exception{
int _i = 0;
 BA.debugLineNum = 250;BA.debugLine="lvNames.Clear";
mostCurrent._lvnames.Clear();
 BA.debugLineNum = 251;BA.debugLine="Cursor = ST.ExecQuery(\"Select * FROM Birds WHERE \" & talen & \" LIKE '%\" & eNaam.Text & \"%' ORDER BY \" & talen & \" Asc\")";
_cursor.setObject((android.database.Cursor)(_st.ExecQuery("Select * FROM Birds WHERE "+_talen+" LIKE '%"+mostCurrent._enaam.getText()+"%' ORDER BY "+_talen+" Asc")));
 BA.debugLineNum = 253;BA.debugLine="If Cursor.RowCount > 0 Then";
if (_cursor.getRowCount()>(int)(0)) { 
 BA.debugLineNum = 254;BA.debugLine="For i = 0 To Cursor.RowCount - 1";
{
final double step198 = 1;
final double limit198 = (int)(_cursor.getRowCount()-1);
for (_i = (int)(0); (step198 > 0 && _i <= limit198) || (step198 < 0 && _i >= limit198); _i += step198) {
 BA.debugLineNum = 255;BA.debugLine="Cursor.Position = i";
_cursor.setPosition(_i);
 BA.debugLineNum = 256;BA.debugLine="lvNames.AddSingleLine(Cursor.GetString(talen))";
mostCurrent._lvnames.AddSingleLine(_cursor.GetString(_talen));
 BA.debugLineNum = 257;BA.debugLine="Next";
}
};
 BA.debugLineNum = 258;BA.debugLine="Else";
}else {
 BA.debugLineNum = 259;BA.debugLine="lvNames.AddSingleLine(\"No bird names containing: \" & eNaam.Text)";
mostCurrent._lvnames.AddSingleLine("No bird names containing: "+mostCurrent._enaam.getText());
 BA.debugLineNum = 260;BA.debugLine="End If";
};
 BA.debugLineNum = 261;BA.debugLine="Cursor.Close";
_cursor.Close();
 BA.debugLineNum = 263;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
taal._process_globals();
about._process_globals();
help._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 BA.debugLineNum = 18;BA.debugLine="Dim eNaam As EditText";
mostCurrent._enaam = new anywheresoftware.b4a.objects.EditTextWrapper();
 BA.debugLineNum = 19;BA.debugLine="Dim pnLV As Panel";
mostCurrent._pnlv = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 20;BA.debugLine="Dim lvNames As ListView";
mostCurrent._lvnames = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 21;BA.debugLine="Dim lNames() As List";
mostCurrent._lnames = new anywheresoftware.b4a.objects.collections.List[(int)(0)];
{
int d0 = mostCurrent._lnames.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._lnames[i0] = new anywheresoftware.b4a.objects.collections.List();
}
}
;
 BA.debugLineNum = 22;BA.debugLine="Dim lblEN As Label";
mostCurrent._lblen = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 23;BA.debugLine="Dim lblDE As Label";
mostCurrent._lblde = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 24;BA.debugLine="Dim lblFR As Label";
mostCurrent._lblfr = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 25;BA.debugLine="Dim lblES As Label";
mostCurrent._lbles = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 26;BA.debugLine="Dim lblIT As Label";
mostCurrent._lblit = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 27;BA.debugLine="Dim lblPT As Label";
mostCurrent._lblpt = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 28;BA.debugLine="Dim lblNL As Label";
mostCurrent._lblnl = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 29;BA.debugLine="Dim lblDK As Label";
mostCurrent._lbldk = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 30;BA.debugLine="Dim lblSC As Label";
mostCurrent._lblsc = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 32;BA.debugLine="Dim pnABC As Panel";
mostCurrent._pnabc = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 33;BA.debugLine="Dim lvABC As ListView";
mostCurrent._lvabc = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 34;BA.debugLine="Dim letter(26) As String";
mostCurrent._letter = new String[(int)(26)];
java.util.Arrays.fill(mostCurrent._letter,"");
 BA.debugLineNum = 35;BA.debugLine="letter = Array As String(\"A\", \"B\", \"C\", \"D\", \"E\", \"F\", \"G\", \"H\", \"I\", \"J\", \"K\", \"L\", \"M\", \"N\", \"O\", \"P\", \"Q\", \"R\", \"S\", \"T\", \"U\", \"V\", \"W\", \"X\", \"Y\", \"Z\")";
mostCurrent._letter = new String[]{"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"};
 BA.debugLineNum = 37;BA.debugLine="Dim vNaam As String";
mostCurrent._vnaam = "";
 BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _help_click() throws Exception{
 BA.debugLineNum = 81;BA.debugLine="StartActivity(Help)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._help.getObject()));
 BA.debugLineNum = 82;BA.debugLine="End Sub";
return "";
}
public static String  _loadabc() throws Exception{
int _i = 0;
 BA.debugLineNum = 100;BA.debugLine="lvABC.SingleLineLayout.ItemHeight = 30dip";
mostCurrent._lvabc.getSingleLineLayout().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 101;BA.debugLine="For i = 0 To 25";
{
final double step74 = 1;
final double limit74 = (int)(25);
for (_i = (int)(0); (step74 > 0 && _i <= limit74) || (step74 < 0 && _i >= limit74); _i += step74) {
 BA.debugLineNum = 102;BA.debugLine="lvABC.AddSingleLine(letter(i))";
mostCurrent._lvabc.AddSingleLine(mostCurrent._letter[_i]);
 BA.debugLineNum = 103;BA.debugLine="Next";
}
};
 BA.debugLineNum = 104;BA.debugLine="End Sub";
return "";
}
public static String  _loadlistview() throws Exception{
int _i = 0;
 BA.debugLineNum = 85;BA.debugLine="lvNames.FastScrollEnabled = True";
mostCurrent._lvnames.setFastScrollEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 86;BA.debugLine="lvNames.SingleLineLayout.ItemHeight = 60dip";
mostCurrent._lvnames.getSingleLineLayout().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(60)));
 BA.debugLineNum = 87;BA.debugLine="lvNames.SingleLineLayout.Label.TextColor = Colors.White";
mostCurrent._lvnames.getSingleLineLayout().Label.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 BA.debugLineNum = 89;BA.debugLine="Cursor = ST.ExecQuery(\"Select * FROM Birds WHERE \" & talen & \" IS NOT NULL ORDER BY \" & talen & \" Asc\")";
_cursor.setObject((android.database.Cursor)(_st.ExecQuery("Select * FROM Birds WHERE "+_talen+" IS NOT NULL ORDER BY "+_talen+" Asc")));
 BA.debugLineNum = 90;BA.debugLine="lvNames.Clear";
mostCurrent._lvnames.Clear();
 BA.debugLineNum = 92;BA.debugLine="For i = 0 To Cursor.RowCount - 1";
{
final double step66 = 1;
final double limit66 = (int)(_cursor.getRowCount()-1);
for (_i = (int)(0); (step66 > 0 && _i <= limit66) || (step66 < 0 && _i >= limit66); _i += step66) {
 BA.debugLineNum = 93;BA.debugLine="Cursor.Position = i";
_cursor.setPosition(_i);
 BA.debugLineNum = 94;BA.debugLine="lvNames.AddSingleLine(Cursor.GetString(talen))";
mostCurrent._lvnames.AddSingleLine(_cursor.GetString(_talen));
 BA.debugLineNum = 95;BA.debugLine="Next";
}
};
 BA.debugLineNum = 96;BA.debugLine="Cursor.Close";
_cursor.Close();
 BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _lvabc_itemclick(int _position,Object _value) throws Exception{
String _result = "";
int _i = 0;
 BA.debugLineNum = 186;BA.debugLine="result = Value & \"%\"";
_result = String.valueOf(_value)+"%";
 BA.debugLineNum = 188;BA.debugLine="Cursor = ST.ExecQuery2(\"SELECT \" & talen & \" FROM Birds WHERE \" & talen & \" LIKE ?\", Array As String(result))";
_cursor.setObject((android.database.Cursor)(_st.ExecQuery2("SELECT "+_talen+" FROM Birds WHERE "+_talen+" LIKE ?",new String[]{_result})));
 BA.debugLineNum = 189;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 191;BA.debugLine="If Cursor.RowCount = 0 Then";
if (_cursor.getRowCount()==(int)(0)) { 
 BA.debugLineNum = 192;BA.debugLine="ToastMessageShow(\"There are no bird names starting with: \" & Value, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("There are no bird names starting with: "+String.valueOf(_value),anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 193;BA.debugLine="Return";
if (true) return "";
 BA.debugLineNum = 194;BA.debugLine="Else";
}else {
 BA.debugLineNum = 195;BA.debugLine="lvNames.Clear";
mostCurrent._lvnames.Clear();
 BA.debugLineNum = 196;BA.debugLine="For i = 0 To Cursor.RowCount - 1";
{
final double step152 = 1;
final double limit152 = (int)(_cursor.getRowCount()-1);
for (_i = (int)(0); (step152 > 0 && _i <= limit152) || (step152 < 0 && _i >= limit152); _i += step152) {
 BA.debugLineNum = 197;BA.debugLine="Cursor.Position = i";
_cursor.setPosition(_i);
 BA.debugLineNum = 198;BA.debugLine="lvNames.AddSingleLine(Cursor.GetString(talen))";
mostCurrent._lvnames.AddSingleLine(_cursor.GetString(_talen));
 BA.debugLineNum = 199;BA.debugLine="Next";
}
};
 BA.debugLineNum = 200;BA.debugLine="End If";
};
 BA.debugLineNum = 202;BA.debugLine="Cursor.Close";
_cursor.Close();
 BA.debugLineNum = 204;BA.debugLine="End Sub";
return "";
}
public static String  _lvnames_itemclick(int _position,Object _value) throws Exception{
 BA.debugLineNum = 107;BA.debugLine="vNaam = value";
mostCurrent._vnaam = String.valueOf(_value);
 BA.debugLineNum = 108;BA.debugLine="pnLV.Visible = False";
mostCurrent._pnlv.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 109;BA.debugLine="StartActivity(\"Main\")";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)("Main"));
 BA.debugLineNum = 111;BA.debugLine="Cursor = ST.ExecQuery2(\"Select ScientificName, NL, EN, ES, FR, DE, PT, IT, DK FROM Birds WHERE \" & talen & \" = ?\", Array As String(vNaam))";
_cursor.setObject((android.database.Cursor)(_st.ExecQuery2("Select ScientificName, NL, EN, ES, FR, DE, PT, IT, DK FROM Birds WHERE "+_talen+" = ?",new String[]{mostCurrent._vnaam})));
 BA.debugLineNum = 112;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 114;BA.debugLine="If Cursor.GetString2(0) <> Null Then";
if (_cursor.GetString2((int)(0))!= null) { 
 BA.debugLineNum = 115;BA.debugLine="lblSC.Text = Cursor.GetString(\"ScientificName\")";
mostCurrent._lblsc.setText((Object)(_cursor.GetString("ScientificName")));
 BA.debugLineNum = 116;BA.debugLine="Else";
}else {
 BA.debugLineNum = 117;BA.debugLine="lblSC.Text = \"-\"";
mostCurrent._lblsc.setText((Object)("-"));
 BA.debugLineNum = 118;BA.debugLine="End If";
};
 BA.debugLineNum = 120;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 121;BA.debugLine="If Cursor.GetString2(1) <> Null Then";
if (_cursor.GetString2((int)(1))!= null) { 
 BA.debugLineNum = 122;BA.debugLine="lblNL.Text = Cursor.GetString(\"NL\")";
mostCurrent._lblnl.setText((Object)(_cursor.GetString("NL")));
 BA.debugLineNum = 123;BA.debugLine="Else";
}else {
 BA.debugLineNum = 124;BA.debugLine="lblNL.Text = \"-\"";
mostCurrent._lblnl.setText((Object)("-"));
 BA.debugLineNum = 125;BA.debugLine="End If";
};
 BA.debugLineNum = 127;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 128;BA.debugLine="If Cursor.GetString2(2) <> Null Then";
if (_cursor.GetString2((int)(2))!= null) { 
 BA.debugLineNum = 129;BA.debugLine="lblEN.Text = Cursor.GetString(\"EN\")";
mostCurrent._lblen.setText((Object)(_cursor.GetString("EN")));
 BA.debugLineNum = 130;BA.debugLine="Else";
}else {
 BA.debugLineNum = 131;BA.debugLine="lblEN.Text = \"-\"";
mostCurrent._lblen.setText((Object)("-"));
 BA.debugLineNum = 132;BA.debugLine="End If";
};
 BA.debugLineNum = 134;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 135;BA.debugLine="If Cursor.GetString2(3) <> Null Then";
if (_cursor.GetString2((int)(3))!= null) { 
 BA.debugLineNum = 136;BA.debugLine="lblES.Text = Cursor.GetString(\"ES\")";
mostCurrent._lbles.setText((Object)(_cursor.GetString("ES")));
 BA.debugLineNum = 137;BA.debugLine="Else";
}else {
 BA.debugLineNum = 138;BA.debugLine="lblES.Text = \"-\"";
mostCurrent._lbles.setText((Object)("-"));
 BA.debugLineNum = 139;BA.debugLine="End If";
};
 BA.debugLineNum = 141;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 142;BA.debugLine="If Cursor.GetString2(4) <> Null Then";
if (_cursor.GetString2((int)(4))!= null) { 
 BA.debugLineNum = 143;BA.debugLine="lblFR.Text = Cursor.GetString(\"FR\")";
mostCurrent._lblfr.setText((Object)(_cursor.GetString("FR")));
 BA.debugLineNum = 144;BA.debugLine="Else";
}else {
 BA.debugLineNum = 145;BA.debugLine="lblFR.Text = \"-\"";
mostCurrent._lblfr.setText((Object)("-"));
 BA.debugLineNum = 146;BA.debugLine="End If";
};
 BA.debugLineNum = 148;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 149;BA.debugLine="If Cursor.GetString2(5) <> Null Then";
if (_cursor.GetString2((int)(5))!= null) { 
 BA.debugLineNum = 150;BA.debugLine="lblDE.Text = Cursor.GetString(\"DE\")";
mostCurrent._lblde.setText((Object)(_cursor.GetString("DE")));
 BA.debugLineNum = 151;BA.debugLine="Else";
}else {
 BA.debugLineNum = 152;BA.debugLine="lblDE.Text = \"-\"";
mostCurrent._lblde.setText((Object)("-"));
 BA.debugLineNum = 153;BA.debugLine="End If";
};
 BA.debugLineNum = 155;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 156;BA.debugLine="If Cursor.GetString2(6) <> Null Then";
if (_cursor.GetString2((int)(6))!= null) { 
 BA.debugLineNum = 157;BA.debugLine="lblPT.Text = Cursor.GetString(\"PT\")";
mostCurrent._lblpt.setText((Object)(_cursor.GetString("PT")));
 BA.debugLineNum = 158;BA.debugLine="Else";
}else {
 BA.debugLineNum = 159;BA.debugLine="lblPT.Text = \"-\"";
mostCurrent._lblpt.setText((Object)("-"));
 BA.debugLineNum = 160;BA.debugLine="End If";
};
 BA.debugLineNum = 162;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 163;BA.debugLine="If Cursor.GetString2(7) <> Null Then";
if (_cursor.GetString2((int)(7))!= null) { 
 BA.debugLineNum = 164;BA.debugLine="lblIT.Text = Cursor.GetString(\"IT\")";
mostCurrent._lblit.setText((Object)(_cursor.GetString("IT")));
 BA.debugLineNum = 165;BA.debugLine="Else";
}else {
 BA.debugLineNum = 166;BA.debugLine="lblIT.Text = \"-\"";
mostCurrent._lblit.setText((Object)("-"));
 BA.debugLineNum = 167;BA.debugLine="End If";
};
 BA.debugLineNum = 169;BA.debugLine="Cursor.Position = 0";
_cursor.setPosition((int)(0));
 BA.debugLineNum = 170;BA.debugLine="If Cursor.GetString2(8) <> Null Then";
if (_cursor.GetString2((int)(8))!= null) { 
 BA.debugLineNum = 171;BA.debugLine="lblDK.Text = Cursor.GetString(\"DK\")";
mostCurrent._lbldk.setText((Object)(_cursor.GetString("DK")));
 BA.debugLineNum = 172;BA.debugLine="Else";
}else {
 BA.debugLineNum = 173;BA.debugLine="lblDK.Text 	= \"-\"";
mostCurrent._lbldk.setText((Object)("-"));
 BA.debugLineNum = 174;BA.debugLine="End If";
};
 BA.debugLineNum = 176;BA.debugLine="Cursor.Close";
_cursor.Close();
 BA.debugLineNum = 178;BA.debugLine="pnLV.Visible = False";
mostCurrent._pnlv.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 179;BA.debugLine="lvNames.Visible = True";
mostCurrent._lvnames.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 180;BA.debugLine="pnABC.Visible = False";
mostCurrent._pnabc.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 181;BA.debugLine="lvABC.Visible = True";
mostCurrent._lvabc.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 183;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 7;BA.debugLine="Dim ST As SQL";
_st = new anywheresoftware.b4a.sql.SQL();
 BA.debugLineNum = 8;BA.debugLine="Dim Cursor As Cursor";
_cursor = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 BA.debugLineNum = 9;BA.debugLine="Dim talen As String";
_talen = "";
 BA.debugLineNum = 10;BA.debugLine="Dim crABC As Cursor";
_crabc = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 BA.debugLineNum = 12;BA.debugLine="End Sub";
return "";
}
public static String  _taal_click() throws Exception{
 BA.debugLineNum = 75;BA.debugLine="StartActivity(Taal)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._taal.getObject()));
 BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
}
