package Species.Translator;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import java.lang.ref.WeakReference;

public class taal extends Activity implements B4AActivity{
	static taal mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    private static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "Species.Translator", "taal");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (taal).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "Species.Translator", "taal");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (taal) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (taal) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return taal.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (taal) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
		processBA.raiseEvent(_activity, "activity_pause", activityBA.activity.isFinishing());
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (taal) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
	
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL.CursorWrapper _crtaal = null;
public static String _talen = "";
public anywheresoftware.b4a.objects.ListViewWrapper _lvtalen = null;
public main _main = null;
public about _about = null;
public help _help = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 BA.debugLineNum = 20;BA.debugLine="Activity.LoadLayout(\"LO_Taal\")";
mostCurrent._activity.LoadLayout("LO_Taal",mostCurrent.activityBA);
 BA.debugLineNum = 21;BA.debugLine="LoadTalen";
_loadtalen();
 BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {}
public static String  _globals() throws Exception{
 BA.debugLineNum = 15;BA.debugLine="Dim lvTalen As ListView";
mostCurrent._lvtalen = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 16;BA.debugLine="End Sub";
return "";
}
public static String  _loadtalen() throws Exception{
 BA.debugLineNum = 26;BA.debugLine="lvTalen.AddSingleLine(\"English\")";
mostCurrent._lvtalen.AddSingleLine("English");
 BA.debugLineNum = 27;BA.debugLine="lvTalen.AddSingleLine(\"Deutsch\")";
mostCurrent._lvtalen.AddSingleLine("Deutsch");
 BA.debugLineNum = 28;BA.debugLine="lvTalen.AddSingleLine(\"Français\")";
mostCurrent._lvtalen.AddSingleLine("Français");
 BA.debugLineNum = 29;BA.debugLine="lvTalen.AddSingleLine(\"Italiano\")";
mostCurrent._lvtalen.AddSingleLine("Italiano");
 BA.debugLineNum = 30;BA.debugLine="lvTalen.AddSingleLine(\"Español\")";
mostCurrent._lvtalen.AddSingleLine("Español");
 BA.debugLineNum = 31;BA.debugLine="lvTalen.AddSingleLine(\"Português\")";
mostCurrent._lvtalen.AddSingleLine("Português");
 BA.debugLineNum = 32;BA.debugLine="lvTalen.AddSingleLine(\"Nederlands\")";
mostCurrent._lvtalen.AddSingleLine("Nederlands");
 BA.debugLineNum = 33;BA.debugLine="lvTalen.AddSingleLine(\"Dansk\")";
mostCurrent._lvtalen.AddSingleLine("Dansk");
 BA.debugLineNum = 34;BA.debugLine="lvTalen.AddSingleLine(\"Scientific\")";
mostCurrent._lvtalen.AddSingleLine("Scientific");
 BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _lvtalen_itemclick(int _position,Object _value) throws Exception{
 BA.debugLineNum = 42;BA.debugLine="talen = Value";
_talen = String.valueOf(_value);
 BA.debugLineNum = 44;BA.debugLine="StartActivity(Main)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._main.getObject()));
 BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 6;BA.debugLine="Dim crTaal As Cursor";
_crtaal = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 BA.debugLineNum = 7;BA.debugLine="Dim talen As String";
_talen = "";
 BA.debugLineNum = 9;BA.debugLine="End Sub";
return "";
}
}
